#ifndef __CONFIG_H_
#define __CONFIG_H_

#if !defined(__C251__) && !defined(__C51__)
#include "../debug.h"
#endif

// ٷͷļ
#include "STC32F.h"

// Cִ֧
#include "intrins.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define PI 3.14159265358979323846
#define _2PI 6.28318530718f
#define _3PI 9.42477796077f
// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long

#define RUN_LED P10
#define UART_LED P07
#define CAN_LED P06
#define DEBUG_LED P05

#define KEY1 P14
#define KEY2 P47

#define REF_IN P54 // 򿪻׼Դرտʡ
#define CSN P40    // űʹ

#define MU P20
#define MUN P21
#define MV P22
#define MVN P23
#define MW P24
#define MWN P25

#define TEST1 P37
#define TEST2 P36
#define TEST3 P35

#define MAIN_Fosc 52000000UL // ʱ
#define Baudrate (65536 - (MAIN_Fosc / 115200 + 2) / 4)

#if (MAIN_Fosc < 30000000UL)
#define WAIT 0x00
#elif (MAIN_Fosc < 60000000UL)
#define WAIT 0x01
#else
#define WAIT 0x02
#endif

// Զ׷Ƶ
// IRCBANDIRCƵѡ񣩼Ĵֵ
#if (MAIN_Fosc > 35000000UL)
#define BAND 0x02
#elif (MAIN_Fosc > 20000000UL)
#define BAND 0x01
#else
#define BAND 0x00
#endif
#define BAND_MASK 0x03

// CLKDIVĴֵϵͳʱƵ
#if (MAIN_Fosc > 15000000UL)
#define DIV 0x01
#elif (MAIN_Fosc > 12000000UL)
#define DIV 0x02
#elif (MAIN_Fosc > 8000000UL)
#define DIV 0x03
#elif (MAIN_Fosc > 6000000UL)
#define DIV 0x04
#else
#define DIV 0x05
#endif

// ׷ƵĴĿֵ
#define MCLK (MAIN_Fosc * DIV)

#if (MCLK < 50000000UL)
#define CNT ((16 * MCLK) / 32768) // Ƶ
#define CREHF 0x00
#else
#define CNT ((8 * MCLK) / 32768) // Ƶ
#define CREHF 0x08
#endif

#define XRES (CNT * 5 / 1000)

#define DIR 1
#define PP 2 // 2Լ

#define voltage_power_supply 12.0 // ߵѹ
#define _constrain(amt, low, high) ((amt) < (low) ? (low) : ((amt) > (high) ? (high) : (amt)))

u32 Micros(void); // ȡϵͳus

extern volatile float Duty_A, Duty_B, Duty_C;

// ͨ˲Ҫȫֱ
typedef struct LowPassConfig
{
    volatile unsigned long int last_time; // ϴʱ
    float last_result;                    // ϴν
} LowPassConfig;

// PIDҪȫֱ
typedef struct PID_Register
{
    volatile unsigned long int timestamp_prev; // ϴʱ
    float P;                                   // Kp
    float I;                                   // Ki
    float D;                                   // Kd
    float output_ramp;                         // ٶ޷
    float limit;                               // ޷
    float error_prev;                          // ϴ
    float output_prev;                         // ϴ
    float integral_prev;                       // ϴλּ
} PID_Register;

// ȫֱ
typedef struct Moto_Config
{
    float set_iq;      // 趨iqֵ
    float set_id;      // 趨idֵ
    float iq;          // q,и
    float id;          // d
    float angle;       // ǰʵʵǶȣи
    float set_speed;   // 趨ٶ
    float speed;       // ǰʵٶ,ٶȻи
    float set_postion; // 趨λ
    float postion;     // ǰʵλãλûи
    float ia;          // U˲
    float ib;          // V˲
    float ic;          // W˲
    float _ia;         // Uʵʵ
    float _ib;         // Vʵʵ
    float _ic;         // Wʵʵ
    u16 ia_verf;       // U׼ѹ
    u16 ib_verf;       // V׼ѹ
    u16 ic_verf;       // W׼ѹ
} Moto_Config;

#endif
