#include "./H_Group/spi.h"

u8 xdata Encoder_Data[3] = {0}; // ݻ
bit SPI_Data_Finish = 0;

void SPI_Init(void)
{
	P_SW2 |= 0x80;                                // չĴ(XFR)ʹ
    P_SW1 |= 0x0c;                                // SPIӿ
    SPSTAT = 0xc0;                                // ־λ
    SPCTL = 0xd4;                                 // SSŹܣʹSPIܣMSBȣģʽ½زݣ/4=52/4=13Mhz
    IE2 &= 0Xfd;                                  // صSPIж
    DMA_SPI_STA = 0x00;                           // DMA־λ
    DMA_SPI_CFG2 = 0x03;                          // ԶSS,SSΪP3.5
    DMA_SPI_CFG = 0xaa;                           // ʹSPI_DMAжϣֹͣաжȼ3߷3
    DMA_SPI_CR = 0x81;                            // SPI_DMAܣʼǰFIFO
    DMA_SPI_RXAH = (u8)((u16)&Encoder_Data >> 8); // SPIݴ洢ַ
    DMA_SPI_RXAL = (u8)((u16)&Encoder_Data);
    DMA_SPI_AMT = 2; // ֻ3ֽ
}

void SPI_DMA_Isr(void) interrupt 49
{
    DMA_SPI_STA = 0;     // жϱ־λ
    SPI_Data_Finish = 1; // ־ȡ
    CSN = 1;             // ʹܣȡ
}

// һζȡ
void Start_Read_Encoder(void)
{
    SPI_Data_Finish = 0; // ɱ־λ
    CSN = 0;             // ʹܱȡ
    DMA_SPI_CR |= 0x40;  // ʼԶȡ
}

// MT6701 CRCУ,Ϊٶȣʱ
u8 crc6_itu(u8 *dat, u8 length)
{
    u8 i;
    u8 crc = 0; // Initial value
    while (length--)
    {
        crc ^= *dat++; // crc ^= *data; data++;
        for (i = 6; i > 0; --i)
        {
            if (crc & 0x20)
                crc = (crc << 1) ^ 0x03;
            else
                crc = (crc << 1);
        }
    }
    return (crc & 0x3f);
}

float last_angle = 0;
volatile long int full_rotation = 0;
volatile unsigned long int speed_time = 0;

float Read_Angle_Data(void)
{
    u16 result;
    float angle, d_angle;
    result = ((Encoder_Data[0] << 8) | (Encoder_Data[1] & 0xfc)) >> 2;
    angle = ((float)result / 16384.0 * 360.0) * (PI / 180);
    speed_time = Micros();
    d_angle = angle - last_angle;
    if (abs(d_angle) > (0.8f * _2PI))
        full_rotation += (d_angle > 0) ? -1 : 1;
    last_angle = angle;
    return angle;
}

float Read_Mechanical_Angle_Data(void)
{
    return _normalizeAngle(Read_Angle_Data() * (float)DIR * (float)PP);
}

volatile unsigned long int speed_last_time = 0;
volatile long int speed_last_full_rotation = 0;
float speed_last_angle = 0;

float Read_Rotation(void)
{
    return (float)full_rotation * _2PI + last_angle;
}

float Read_One_Rotation(void)
{
    return (float)last_angle;
}

float Ts = 0;
float speed = 0;
float Read_Speed_Data(void)
{    
		speed_time = Micros();
    Ts = (speed_time - speed_last_time) * 1e-6;
    if (Ts <= 0)
        Ts = 1e-3f;
    speed = ((float)(speed_last_full_rotation - full_rotation) * _2PI + (speed_last_angle - last_angle)) / Ts;
    speed = (speed / _2PI * 60); // Ϊrpm
    // 
    speed_last_time = speed_time;
    speed_last_full_rotation = full_rotation;
    speed_last_angle = last_angle;
    return speed; // ٶֵ
}
